﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace csharpsvctest
{
    public partial class Form1 : Form
    {
        public bool _bConnected = false;
        
        public Form1()
        {
            InitializeComponent();

            // Init status
            ComboViewStream.SelectedIndex = 0;
            ComboProtocol.SelectedIndex = 1;
            comboDecodeLvl.SelectedIndex = 8;
            comboFrameLvl.SelectedIndex = 8;

            ButtonEnalbe(false);
        }

        private void BtnConnect_Click(object sender, EventArgs e)
        {
            // URL
            string strPreIP = "http://";

            if (IPTxt.TextLength != 0)
                axVitaminCtrl1.Url = strPreIP + IPTxt.Text;

            // Port
            axVitaminCtrl1.HttpPort = Convert.ToInt32(PortTxt.Text);

            // User name
            if (UserNameTxt.TextLength != 0)
                axVitaminCtrl1.UserName = UserNameTxt.Text;

            // Password
            if (PasswordTxt.TextLength != 0)
                axVitaminCtrl1.Password = PasswordTxt.Text;

            // View stream
            axVitaminCtrl1.ViewStream = (VITAMINDECODERLib.EDualStreamOption)ComboViewStream.SelectedIndex.GetHashCode();

            // Protocol
            axVitaminCtrl1.ConnectionProtocol = (VITAMINDECODERLib.EConnProtocol)ComboProtocol.SelectedIndex.GetHashCode() + 1;

            axVitaminCtrl1.Connect();
        }

        private void BtnDisconnect_Click(object sender, EventArgs e)
        {
            axVitaminCtrl1.Disconnect();

            // Restore status
            CodecChkJpeg.Checked = false;
            CodecChkMpeg4.Checked = false;
            CodecChkH264.Checked = false;
            comboDecodeLvl.SelectedIndex = 8;
            comboFrameLvl.SelectedIndex = 8;
            _bConnected = false;

            ButtonEnalbe(false);
        }

        private void BtnSetFrameInterval_Click(object sender, EventArgs e)
        {
            axVitaminCtrl1.SVCTFrameInterval = Convert.ToInt32(textFrameInterval.Text);
        }

        // VitaminCtrl event handle
        private void axVitaminCtrl1_OnVideoCodec(object sender, AxVITAMINDECODERLib._IVitaminCtrlEvents_OnVideoCodecEvent e)
        {
            if (e.eVideoCodec == VITAMINDECODERLib.EVideoCodecType.eViCodecMJpeg)
            {
                CodecChkJpeg.Checked = true;
                textFrameInterval.Enabled = true;
                BtnSetFrameInterval.Enabled = true;
            }
            else if (e.eVideoCodec == VITAMINDECODERLib.EVideoCodecType.eViCodecSP)
            {
                CodecChkMpeg4.Checked = true;
            }
            else if (e.eVideoCodec == VITAMINDECODERLib.EVideoCodecType.eViCodecH264)
            {
                CodecChkH264.Checked = true;
                comboDecodeLvl.Enabled = true;
                comboFrameLvl.Enabled = true;
            }
        }

        private void axVitaminCtrl1_OnConnectionOK(object sender, AxVITAMINDECODERLib._IVitaminCtrlEvents_OnConnectionOKEvent e)
        {
            _bConnected = true;
            BtnDisconnect.Enabled = true;
        }

        // Form event handle
        private void ViewStreamCombo_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (_bConnected)
            {
                _bConnected = false;
                axVitaminCtrl1.ViewStream = (VITAMINDECODERLib.EDualStreamOption)((System.Windows.Forms.ComboBox)sender).SelectedIndex.GetHashCode();
            }
        }

        private void comboDecodeLvl_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (_bConnected)
            {
                axVitaminCtrl1.SVCTDecodeLevel = ((System.Windows.Forms.ComboBox)sender).SelectedIndex.GetHashCode();
            }
        }

        private void comboFrameLvl_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (_bConnected)
            {
                axVitaminCtrl1.SVCTFrameLevel = ((System.Windows.Forms.ComboBox)sender).SelectedIndex.GetHashCode();
            }
        }
    }
}
